/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.oracle.psr;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.concurrent.atomic.AtomicLong;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingEnumeration;
import javax.naming.Binding;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author soaks
 */
public class PingServlet extends HttpServlet {
    //boolean check = listAllContext();
    PingSessionSFSBLocal pingSessionSFSB = lookupPingSessionSFSBLocal();
    //PingRemoteSessionSFSBInterface pingRemoteSessionSFSB = lookupPingRemoteSessionSFSB();
    @EJB
    private PingSessionSLSBLocal pingSessionSLSB;
    //@EJB
    //private PingRemoteSessionSLSBInterface pingRemoteSessionSLSB;
    private static AtomicLong hitCount = new AtomicLong();


    private boolean listAllContext() {
        try {
		Context ctx = (Context)new InitialContext().lookup("java:comp");
        	listContext(ctx, "");
	} catch (NamingException e) {
		System.out.println("Lookup Failure:" + e.toString());
	}
        return true;
    }
 
   /*** Recursively exhaust the JNDI tree*/
  private static final void listContext(Context ctx, String indent) {
	System.out.println("================================Listing of all JNDI binding under java:global===============================");
        try {   
		NamingEnumeration list = ctx.listBindings("");
		while (list.hasMore()) {
		       Binding item = (Binding) list.next();
		       String className = item.getClassName();  
		       String name = item.getName();
		       System.out.println( indent + className + " [" + name + "]");
		       Object o = item.getObject();
		       if (o instanceof javax.naming.Context) {
				listContext((Context) o, indent + " "); 
		       }   
		}
	} catch (NamingException ex) {
	   System.out.println("JNDI failure: " + ex.toString());
	}

    }

    /**
     * Processes requests for both HTTP
     * <code>GET</code> and
     * <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        String action = request.getParameter("action");
        if (action==null) 
		action="test";
        try {
            if (action.equals("local")) {
                doLocal(request, response, out);
            } else if (action.equals("remote")) {
            	doRemote(request, response, out);
            } else if (action.equals("localsfsb")) {
                doLocalSFSB(request, response, out);
            } else if (action.equals("remotesfsb")) {
            	//doRemoteSFSB(request, response, out);
            } else if (action.equals("test")){
                out.println("<html>");
                out.println("<body>");
                out.println("200 OK");
                out.println("</body>");
                out.println("</html>");    	
	    } else {
                throw new ServletException("Unexpected action " + action);
            }
        } finally {
            out.close();
        }
    }
    

    private void doLocal(HttpServletRequest req, HttpServletResponse resp, PrintWriter out)
            throws IOException {
        pingSessionSLSB.ping();
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Ping SLSB</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<HR><BR>Ping SLSB<BR>Hit Count: " + hitCount.incrementAndGet());
        out.println("</body>");
        out.println("</html>");
    }

    private void doRemote(HttpServletRequest req, HttpServletResponse resp, PrintWriter out)
            throws IOException {
        //pingRemoteSessionSLSB.ping();
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Ping Remote SLSB</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<HR><BR>Ping Remote SLSB<BR>Hit Count: " + hitCount.incrementAndGet());
        out.println("</body>");
        out.println("</html>");
    }
    
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    private void doLocalSFSB(HttpServletRequest request, HttpServletResponse response, PrintWriter out) throws ServletException {
        HttpSession session = request.getSession();
        String test = request.getParameter("test");
        if (test.equals("create")) {
            PingSessionSFSBLocal sfsb = lookupPingSessionSFSBLocal();
        }
        else if (test.equals("invoke")) {
            PingSessionSFSBLocal sfsb = (PingSessionSFSBLocal) session.getAttribute("sfsb");
            if (sfsb == null) {
                sfsb = lookupPingSessionSFSBLocal();
                session.setAttribute("sfsb", sfsb);
            }
            sfsb.ping();
        }
        else if (test.equals("remove")) {
            PingSessionSFSBLocal sfsb = lookupPingSessionSFSBLocal();
            sfsb.remove();
        }
        else throw new ServletException("Unknown test parameter " + test);
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Ping SFSB</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<HR><BR>Ping SFSB<BR>Hit Count: " + hitCount.incrementAndGet());
        out.println("</body>");
        out.println("</html>");
    }

   /*private void doRemoteSFSB(HttpServletRequest request, HttpServletResponse response, PrintWriter out) throws ServletException {
        HttpSession session = request.getSession();
        String test = request.getParameter("test");
        if (test.equals("create")) {
            PingRemoteSessionSFSBInterface sfsb = lookupPingRemoteSessionSFSB();
        }
        else if (test.equals("invoke")) {
            PingRemoteSessionSFSBInterface sfsb = (PingRemoteSessionSFSBInterface) session.getAttribute("sfsb");
            if (sfsb == null) {
                sfsb = lookupPingRemoteSessionSFSB();
                session.setAttribute("sfsb", sfsb);
            }
            sfsb.ping();
        }
        else if (test.equals("remove")) {
            PingRemoteSessionSFSBInterface sfsb = lookupPingRemoteSessionSFSB();
            sfsb.remove();
        }
        else throw new ServletException("Unknown test parameter " + test);
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Ping Remote SFSB</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<HR><BR>Ping Remote SFSB<BR>Hit Count: " + hitCount.incrementAndGet());
        out.println("</body>");
        out.println("</html>");
    }    
    */
    private PingSessionSFSBLocal lookupPingSessionSFSBLocal() {
        try {
            Context c = new InitialContext();
	    return (PingSessionSFSBLocal) c.lookup("java:global/EJBSessionLocal/EJBSession-ejb/PingSessionSFSB!com.oracle.psr.PingSessionSFSBLocal");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }
    
/*    private PingRemoteSessionSFSBInterface lookupPingRemoteSessionSFSB() {
        try {
            Context c = new InitialContext();
	    return (PingRemoteSessionSFSBInterface) c.lookup("PingRemoteSessionSFSB#com.oracle.psr.PingRemoteSessionSFSBInterface");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }    */
}
